%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function display_image_with_correct_gray_scale(the_axes,the_axes_tag,...
    image,client_handles,server_1_handles)

%Nasser Abbasi 062508
%
%Common function called from different places in the simulator to display
%an image with correct gray scale.

    function     display_the_user_image()
        axes(the_axes);
        if get(client_handles.phantomBtn,'Value')==1 || get(client_handles.paperclipPhantomTag,'Value')==1
            imshow(image);
        else
            imshow(image,[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel],...
                'Parent',the_axes);
        end
        add_colorbar(the_axes,0.056);
    end

    function display_error_plot()
        h = subplot(1,1,1,'Parent',server_1_handles.error_server1_panel_tag);
        if get(server_1_handles.absErrorDiffEnhanceTag,'Value')==1
            image(image<mean(image(:)))=0;
            image(image>=mean(image(:)))=1;

            imshow(image,'Parent',h);
        else
            imshow(image,[],'Parent',h);
        end
    end

    function display_mask
        axes(the_axes);

        if get(server_1_handles.enhance_ratio_off_mean_server1_tag,'Value')==1
            imshow(image,[min(image(:)) mean(image(:))]);
        else
            imshow(image,[]);
        end

        add_colorbar(the_axes,0.06);
    end

    function display_HYPR_image

        axes(server_1_handles.server_1_HYPR_Axes);

        if get(client_handles.phantomBtn,'Value')==1 || ...
                get(client_handles.paperclipPhantomTag,'Value')==1
            if get(client_handles.client_FBP_btn,'Value')==1
                imshow(image,[]);
            else
                imshow(image);
            end
        else
            if get(server_1_handles.server_1_enhance_HYPR_tag,'Value')==1
                image(image<mean(image(:)))  = 0;
                image(image>=mean(image(:))) = 1;

                imshow(image);
            else
                imshow(image,[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
            end
        end

        add_colorbar(server_1_handles.server_1_HYPR_Axes,0.14);
    end

    function display_composite
        axes(server_1_handles.server_1_C_Axes);
        if get(server_1_handles.enhance_off_mean_C_server1_tag,'Value')==1
            imshow(image,[min(image(:)) mean(image(:))]);
        else
            if get(client_handles.phantomBtn,'Value')==1 || get(client_handles.paperclipPhantomTag,'Value')==1
                imshow(image);
            else
                imshow(image,[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
            end
        end

        add_colorbar(server_1_handles.server_1_C_Axes,0.048);
    end

if strcmp(the_axes_tag,'server_1_mask_Axes')==1
    display_mask();
    return;
end

if strcmp(the_axes_tag,'CImageAxes')==1
    display_composite();
    return;
end

if strcmp(the_axes_tag,'currentHYPRFrame2Axes')==1
    display_HYPR_image();
    return;
end

if strcmp(the_axes_tag,'histogramAxes')==1
    display_error_plot();
    return;
end

if strcmp(the_axes_tag,'originalImage2Axes')==1
    display_the_user_image();
    return;
end

axes(the_axes);

if get(client_handles.wrightPaperDiskTag,'Value')==1
    imshow(uint8(image),[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
else
    imshow(uint16(image),[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
end
add_colorbar(the_axes,0.038);


end