%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************

function display_projection_vector(axes_handle,degree)
%function display_projection_vector(axes_handle,degree)

%a quick algorithm hack to draw projection lines to
%make it look nicer to see. I Will clean up later.
%Nasser Abbasi 071808

    function [x,y,xx,yy]=flip_points(x1,y1,x2,y2)
        x=x2;
        y=y2;
        xx=x1;
        yy=y1;
    end

    function make_quiver(x1,y1,x2,y2,flip_it)
        if flip_it
            [x1,y1,x2,y2]=flip_points(x1,y1,x2,y2);
        end
        u = x2-x1;
        v = y2-y1;
        quiver(x1,y1,u,v,...
            1,...
            'filled',...
            'k',...
            'Parent',...
            axes_handle);
    end

x=[-1 1 1 -1]; y=[-1 -1 1 1];
fill(x,y,[.9,.9,0.9],'Parent',axes_handle);
set(axes_handle,'Xlim',[-3 3],'Ylim',[-3 3]);
clear_tick_marks_from_axes(axes_handle);

hold(axes_handle,'on');
axes(axes_handle);
plot([0 0],[-1 1],'--');
plot([-1 1],[0 0],'--');
theta = degree+90;

before_coords = [2 2;
    -2 2;
    2 1;
    -2 1;
    2 -1;
    -2 -1;
    2 -2;
    -2 -2;
    2 0;
    -2 0
    ];

[nRow,nCol]  = size(before_coords);
after_coords = zeros(nRow,nCol);
A=[cosd(theta) -sind(theta);
    sind(theta) cosd(theta)];

for i=1:nRow
    v = A*[before_coords(i,1) before_coords(i,2)]';
    after_coords(i,1)=v(1);
    after_coords(i,2)=v(2);
end

if after_coords(9,1)<=0
    flip_it=true;
else
    flip_it=false;
end

for i=1:2:nRow
    make_quiver(after_coords(i,1),after_coords(i,2),...
        after_coords(i+1,1),after_coords(i+1,2),flip_it);
end

clear_tick_marks_from_axes(axes_handle);
hold(axes_handle,'off');

end
