%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function image = filter_LR(image,client_handles)

if get(client_handles.client_LR_average_tag,'Value')==1
   order_of_filter = get_order(client_handles.client_LR_average_tag);       
   h = fspecial('average',order_of_filter);
   image = imfilter(image,h,'conv','replicate');
   
elseif get(client_handles.client_LR_gaussian_tag,'Value')==1
    order_of_filter =  get_order(client_handles.client_filter_LR_order_gaussian_tag);
    sigma = str2double(get(client_handles.client_filter_LR_sigma_gaussian_tag,'String'));    
    h     = fspecial('gaussian', order_of_filter, sigma);
    image = imfilter(image,h,'conv','replicate');
    
elseif  get(client_handles.client_LR_circle_tag,'Value')==1
    radius_of_filter = str2double(get(client_handles.client_filter_LR_r_circle_tag,'String'));    
    h     = fspecial('disk', radius_of_filter);
    image = imfilter(image,h,'conv','replicate');
    
elseif get(client_handles.client_LR_median_tag,'Value')==1
    order_of_filter = get_order(client_handles.client_filter_LR_order_median_tag);
    image = medfilt2(image,[order_of_filter order_of_filter]);
    
else %wiener
    order_of_filter = get_order(client_handles.client_filter_order_wiener_tag);
    image = wiener2(image,[order_of_filter order_of_filter]);
end

end
%%%%%%%%%%%%
%
%%%%%%%%%%%%
function r = get_order(tag)
k = get(tag,'Value');
r = k + 2;
end   