%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************

function find_SNR_and_update_log_file(hObject,...
    HYPR_frame_noise,...
    currentC_noise)

client_handles   = guidata(hObject);
server_1_handles = guidata(client_handles.userData.server_1_handle);


%
% This function is called from HYPR algorithms to calculated noise
% statistics
%
mean_HYPR      = mean(HYPR_frame_noise(:));
mean_composite = mean(currentC_noise(:));
std_HYPR       = std(HYPR_frame_noise(:));
std_composite  = std(currentC_noise(:));
MSE_HYPR       = mean_HYPR^2 + std_HYPR ^2;     %adjusted 071808
MSE_composite  = mean_composite^2 + std_composite ^2;

update_SNR_UI_counter(...
    server_1_handles,...
    MSE_HYPR,...
    MSE_composite,...
    std_HYPR,...
    std_composite,...
    mean_HYPR,...
    mean_composite);

client_handles.userData.stats_struct.noise_hypr_mean = mean_HYPR;
client_handles.userData.stats_struct.noise_hypr_std  = std_HYPR;
client_handles.userData.stats_struct.noise_hypr_mse  = MSE_HYPR;
client_handles.userData.stats_struct.noise_C_mean    = mean_composite;
client_handles.userData.stats_struct.noise_C_std     = std_composite;
client_handles.userData.stats_struct.noise_C_mse     = MSE_composite;

guidata(hObject,client_handles);

end
