%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function status = generateDataForDiskWithHoleTag(hObject)

status = 1;
[client_handles,server_1_handles]=pre_process_data_generation(hObject,1,128,256);

rad1 = 50;
rad2 = 20; %left side

cx1    = 26;
cx2    = 60;

diskOne  = nma_makeDisk(client_handles.userData.sz,rad1,cx1,0,...
    client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);
diskTwo  = nma_makeDisk(client_handles.userData.sz,rad2,cx2,0,...
    client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);

grayLevelsDiskOne  = linspace(client_handles.userData.minGrayLevel,...
    client_handles.userData.maxGrayLevel,...
    client_handles.userData.totalNumberOfProjections);

[r1,c1] = find(diskOne==client_handles.userData.maxGrayLevel); %find the circle
ind1    = sub2ind([client_handles.userData.sz,client_handles.userData.sz],r1,c1);
[r2,c2] = find(diskTwo==client_handles.userData.maxGrayLevel); %find the circle
ind2    = sub2ind([client_handles.userData.sz,client_handles.userData.sz],r2,c2);

currentProjectionNumber = 0;
currentFrameNumber      = 1;
tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);

for i = 1:client_handles.userData.totalNumberOfProjections
    currentProjectionNumber=currentProjectionNumber+1;
    diskOne(ind1) = grayLevelsDiskOne(i);
    A = diskOne+diskTwo;
    A(ind2) = 0;

    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    client_handles.userData.userImages(:,:,i) = A;

    [currentFrameNumber,currentProjectionNumber]=...
        data_generation_LOOP_update(client_handles,server_1_handles,A,...
        currentProjectionNumber,currentFrameNumber);
end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles);  %only save images if not aborted

end