%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function status = generateDataForFig2IHYPRPaper(hObject)

status = 1;
[client_handles,server_1_handles]=pre_process_data_generation(hObject,0,1,256);

r_A1 = 6;
r_A2 = 6;
r_A3 = 6;

cx_A1  = -50;
cy_A1  = 50;

cx_A2   = 50;
cy_A2   = -50;

cx_A3 = cx_A2+r_A2+2+r_A3;
cy_A3 = cy_A2;

gray_level_for_A1 = make_gray_level_for_A1(client_handles.userData.totalNumberOfProjections,...
    client_handles.userData.minGrayLevel,...
    client_handles.userData.maxGrayLevel);

gray_level_for_A2 = make_gray_level_for_A2(client_handles.userData.totalNumberOfProjections,...
    client_handles.userData.minGrayLevel,...
    client_handles.userData.maxGrayLevel);

gray_level_for_A3 = make_gray_level_for_A3(client_handles.userData.totalNumberOfProjections,...
    client_handles.userData.minGrayLevel,...
    client_handles.userData.maxGrayLevel);

currentProjectionNumber = 0;
currentFrameNumber      = 1;
tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);

for i = 1:client_handles.userData.totalNumberOfProjections

    A1 = nma_makeDisk(client_handles.userData.sz ,...
        r_A1,...
        cx_A1,...
        cy_A1,...
        client_handles.userData.minGrayLevel,...
        client_handles.userData.maxGrayLevel);
    A1(A1>0) = gray_level_for_A1(i);

    A2 = nma_makeDisk(client_handles.userData.sz ,...
        r_A2,...
        cx_A2,...
        cy_A2,...
        client_handles.userData.minGrayLevel,...
        client_handles.userData.maxGrayLevel);
    A2(A2>0) = gray_level_for_A2(i);

    A3 = nma_makeDisk(client_handles.userData.sz ,...
        r_A3,...
        cx_A3,...
        cy_A3,...
        client_handles.userData.minGrayLevel,...
        client_handles.userData.maxGrayLevel);
    A3(A3>0) = gray_level_for_A3(i);

    currentProjectionNumber=currentProjectionNumber+1;

    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    A = A1+A2+A3;

    client_handles.userData.userImages(:,:,i) =  A;
    [currentFrameNumber,currentProjectionNumber]=...
        data_generation_LOOP_update(client_handles,server_1_handles,A,...
        currentProjectionNumber,currentFrameNumber);
end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles);  %only save images if not aborted

end
%%%%%%%%%%%%%
%
%%%%%%%%%%%%%
function g=make_gray_level_for_A1(nProjections,minI,maxI)
s=floor(nProjections/30);
left_over = nProjections-30*s;

g1=linspace(minI,minI,10*s);
g2=linspace(minI,0.7*maxI,2*s);
g3=linspace(0.7*maxI,0.8*maxI,2*s);
g4=linspace(0.8*maxI,0.7*maxI,2*s);
g5=linspace(0.7*maxI,0.2*maxI,10*s);
g6=linspace(0.2*maxI,minI,4*s+left_over);

g=[g1 g2 g3 g4 g5 g6];

end
%%%%%%%%%%%%%
%
%%%%%%%%%%%%%
function g=make_gray_level_for_A2(nProjections,minI,maxI)
s=floor(nProjections/30);
left_over = nProjections-30*s;

g1=linspace(minI,minI,10*s);
g2=linspace(minI,0.7*maxI,2*s);
g3=linspace(0.7*maxI,maxI,2*s);
g4=linspace(maxI,maxI,2*s);
g5=linspace(maxI,0.2*maxI,10*s);
g6=linspace(0.2*maxI,minI,4*s+left_over);

g=[g1 g2 g3 g4 g5 g6];
end

%%%%%%%%%%%%%
%
%%%%%%%%%%%%%
function g=make_gray_level_for_A3(nProjections,minI,maxI)
s=floor(nProjections/30);
left_over = nProjections-30*s;

g1=linspace(minI,minI,15*s);
g2=linspace(minI,0.8*maxI,2*s);
g3=linspace(0.8*maxI,maxI,2*s);
g4=linspace(maxI,maxI,2*s);
g5=linspace(maxI,0.2*maxI,10*s);
g6=linspace(0.2*maxI,minI,4*s+left_over);

g=[g1 g2 g3 g4 g5 g6];
end