%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function status = generateDataForLineImpulse(hObject)

status = 1;
[client_handles,server_1_handles]=pre_process_data_generation(hObject,0,1,256);

I=nma_makeRectangular(256,-128,-1,128,1,0,1);

currentProjectionNumber = 0;
currentFrameNumber      = 1;
tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);

projection_to_make_impulse_at = round(client_handles.userData.totalNumberOfProjections/2);

for i = 1:client_handles.userData.totalNumberOfProjections

    currentProjectionNumber=currentProjectionNumber+1;

    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    A0 = zeros(256);

    if i == projection_to_make_impulse_at
        A = I;
    else
        A = A0;
    end

    client_handles.userData.userImages(:,:,i) =  A;
    [currentFrameNumber,currentProjectionNumber]=...
        data_generation_LOOP_update(client_handles,server_1_handles,A,...
        currentProjectionNumber,currentFrameNumber);
end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles);  %only save images if not aborted

end

