%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function status = generateDataForPhantom(hObject)

status = 1;
client_handles   = guidata(hObject);
server_1_handle  = client_handles.userData.server_1_handle;
server_1_handles = guidata(server_1_handle);

client_handles.userData.minGrayLevel = 0;
client_handles.userData.maxGrayLevel = 1;
client_handles.userData.sz = 128;

A = phantom('Modified Shepp-Logan', client_handles.userData.sz );

guidata(hObject,client_handles);
initlializeDataGeneration(hObject);
client_handles = guidata(hObject);

currentProjectionNumber = 0;
currentFrameNumber      = 1;

tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);


for i = 1:client_handles.userData.totalNumberOfProjections
    currentProjectionNumber = currentProjectionNumber +1;
    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    client_handles.userData.userImages(:,:,i) =  A;
    [currentFrameNumber,currentProjectionNumber]=...
        data_generation_LOOP_update(client_handles,server_1_handles,A,...
        currentProjectionNumber,currentFrameNumber);

    pause(.01);
end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles);  %only save images if not aborted

end
