%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function  status = generateDataForTimeInvarientDisk(hObject)

status = 1;
[client_handles,server_1_handles]=pre_process_data_generation(hObject,1,128,128);

radius      = 10;   %in pixels radius of disk
cy   = 0;
cx1  = 11;
cx2  = -11;

currentProjectionNumber = 0;
currentFrameNumber      = 1;
tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);

for i = 1:client_handles.userData.totalNumberOfProjections
    A = nma_makeDisk(client_handles.userData.sz ,radius,round(cx1),...
        cy,client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);
    A = A + nma_makeDisk(client_handles.userData.sz ,radius,round(cx2),cy,...
        client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);

    currentProjectionNumber = currentProjectionNumber+1;
    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    client_handles.userData.userImages(:,:,i) =  A;
    [currentFrameNumber,currentProjectionNumber]=...
        data_generation_LOOP_update(client_handles,server_1_handles,A,...
        currentProjectionNumber,currentFrameNumber);
end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles);  %only save images if not aborted

end
