%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function status = generateDataForTwoDisksDifferentIntensity(hObject)

status = 1;
[client_handles,server_1_handles]=pre_process_data_generation(hObject,1,128,256);

rad1 = 25;
rad2 = 25; %left side
rad3 = 25;
cx1    = 26;
cx2    = -26;
cx3    = -10;
cy3    = 48;

diskOne  = nma_makeDisk(client_handles.userData.sz,rad1,cx1,0,...
    client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);
diskTwo  = nma_makeDisk(client_handles.userData.sz,rad2,cx2,0,...
    client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);
diskThree  = nma_makeDisk(client_handles.userData.sz,rad3,cx3,cy3,...
    client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);

grayLevelsDiskOne  = linspace(client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel,...
    client_handles.userData.totalNumberOfProjections);
grayLevelsDiskTwo  = linspace(client_handles.userData.minGrayLevel,.75*client_handles.userData.maxGrayLevel,...
    client_handles.userData.totalNumberOfProjections);
grayLevelsDiskThree  = linspace(client_handles.userData.minGrayLevel,.4*client_handles.userData.maxGrayLevel,...
    client_handles.userData.totalNumberOfProjections);

[r1,c1] = find(diskOne==client_handles.userData.maxGrayLevel); %find the circle
ind1    = sub2ind([client_handles.userData.sz,client_handles.userData.sz],r1,c1);
[r2,c2] = find(diskTwo==client_handles.userData.maxGrayLevel); %find the circle
ind2    = sub2ind([client_handles.userData.sz,client_handles.userData.sz],r2,c2);
[r3,c3] = find(diskThree==client_handles.userData.maxGrayLevel); %find the circle
ind3    = sub2ind([client_handles.userData.sz,client_handles.userData.sz],r3,c3);

currentProjectionNumber = 0;
currentFrameNumber      = 1;
tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);

for i = 1:client_handles.userData.totalNumberOfProjections
    currentProjectionNumber=currentProjectionNumber+1;

    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    diskOne(ind1) = grayLevelsDiskOne(i);
    diskTwo(ind2) = grayLevelsDiskTwo(i);
    diskThree(ind3) = grayLevelsDiskThree(i);
    A = diskOne+diskTwo+diskThree;

    client_handles.userData.userImages(:,:,i) = A;

    [currentFrameNumber,currentProjectionNumber]=...
        data_generation_LOOP_update(client_handles,server_1_handles,A,...
        currentProjectionNumber,currentFrameNumber);
end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles);  %only save images if not aborted

end


