function status = generateDataForWrightHuang(hObject)
%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
%
% server1 state is  0=PAUSE,1=PLAY,2=move to next projection
%    3=move to end of frame, 4=cancel

status = 1;
client_handles   = guidata(hObject);
server_1_handle  = client_handles.userData.server_1_handle;
server_1_handles = guidata(server_1_handle);

client_handles.userData.minGrayLevel = 0;  %Changed on  7/23/08 
client_handles.userData.maxGrayLevel = 128;
client_handles.userData.sz           = 256;
guidata(hObject,client_handles);

initlializeDataGeneration(hObject);
client_handles = guidata(hObject);

A  = nma_makeDisk(client_handles.userData.sz,25,0,0,...
    client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel);

grayLevels   = linspace(client_handles.userData.minGrayLevel,client_handles.userData.maxGrayLevel,...
    client_handles.userData.totalNumberOfProjections);
[r,c]        = find(A==128); %find the circle
ind          = sub2ind([client_handles.userData.sz,client_handles.userData.sz],r,c);
x            = 1:client_handles.userData.totalNumberOfProjections;

currentProjectionNumber = 0;
currentFrameNumber      = 1;

tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);

for i = 1:client_handles.userData.totalNumberOfProjections
    currentProjectionNumber=currentProjectionNumber+1;
    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    A(ind)            = grayLevels(i);
    client_handles.userData.userImages(:,:,i) = A;

    display_image_with_correct_gray_scale(...
        server_1_handles.originalImage2Axes,...
        'originalImage2Axes',...
        A,...
        client_handles,...
        server_1_handles);

    if currentProjectionNumber == client_handles.userData.nProjectionsPerFrame
        currentFrameNumber = currentFrameNumber  + 1;
        currentProjectionNumber = 0;
        if currentFrameNumber<=client_handles.userData.nTimeFrames
            set(server_1_handles.currentFrameNumberTag,'String',...
                sprintf('%d',currentFrameNumber));
        end
    end

    %     axes(server_1_handles.temporalProfileAxes);
    %     plot(x(1:i),grayLevels(1:i));
    %     xlabel('Time (in number of projections)');
    %     ylabel('signal intensity');
    %     set(get(gca,'YLabel'),'Rotation',90);
    %     xlim([0 client_handles.userData.totalNumberOfProjections]);
    %     ylim([client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.xValuesForTemporalProfile = x;
client_handles.userData.yValuesForTemporalProfile = grayLevels;
client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles);  %only save images if not aborted

