%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function status = generateDataForpaperclipPhantom(hObject)

%
% server1 state is  0=PAUSE,1=PLAY,2=move to next projection
%    3=move to end of frame, 4=cancel
status = 1;
client_handles   = guidata(hObject);
server_1_handles = guidata(client_handles.userData.server_1_handle);

data=load('paperclip_phantom.mat');
theImage = data.im;

client_handles.userData.minGrayLevel = min(theImage(:));
client_handles.userData.maxGrayLevel = max(theImage(:));
client_handles.userData.sz = size(theImage,1);

guidata(hObject,client_handles);
initlializeDataGeneration(hObject);
client_handles = guidata(hObject);

currentProjectionNumber = 0;
currentFrameNumber      = 1;

tmp = guidata(hObject);
set(server_1_handles.currentFrameNumberTag,'String',currentFrameNumber);

for i = 1:client_handles.userData.totalNumberOfProjections

    currentProjectionNumber=currentProjectionNumber+1;
    set(server_1_handles.server_1_projection_number_tag,'String',currentProjectionNumber );

    tmp = guidata(hObject);
    if tmp.interrupt_state.server1_state == 4
        status = 0;
        break;
    end

    client_handles.userData.userImages(:,:,i) =  theImage(:,:,i);

    display_image_with_correct_gray_scale(...
        server_1_handles.originalImage2Axes,...
        'originalImage2Axes',...
        theImage(:,:,i),...
        client_handles,...
        server_1_handles);

    if currentProjectionNumber == client_handles.userData.nProjectionsPerFrame
        currentFrameNumber = currentFrameNumber  + 1;
        currentProjectionNumber = 0;
        if currentFrameNumber<=client_handles.userData.nTimeFrames
            set(server_1_handles.currentFrameNumberTag,'String',...
                sprintf('%d',currentFrameNumber));
        end
    end

end

if tmp.interrupt_state.server1_state == 4
    return;
end

client_handles.userData.userImagesCreated = 1;
guidata(hObject,client_handles); %only save images if not aborted
