function angles = getAngles(hObject,totalNumberOfProjections)
%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
handles  = guidata(hObject);

viewHandle    = get(handles.viewModeGroupTag,'SelectedObject');
viewHandleTag = get(viewHandle,'Tag');
startAngle    = 0;
endingAngle   = 180;

if strcmp(viewHandleTag,'partialViewTag')
    startAngle  = str2double(get(handles.startAngleTag,'String'));
    endingAngle = str2double(get(handles.endingAngleTag,'String'));
end

%use bit reversed ordering for projection angles
angles = linspace(startAngle,endingAngle,totalNumberOfProjections);
z      = log(totalNumberOfProjections)/log(2);

if abs(z-round(z))<eps %is totalNumberOfProjections a power of 2 ?
    angles = bitrevorder(angles);
end

