%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function C = get_sliding_window_composite_image(client_handles,...
    centered_frame_number,...
    size_of_window,...
    noise_process)

left_end_of_window  = centered_frame_number - floor(size_of_window/2);
right_end_of_window = centered_frame_number + floor(size_of_window/2);

left_over = 0;
if left_end_of_window <= 0
    left_over = abs(left_end_of_window)+1;
    left_end_of_window = 1;
end

right_over = 0;
if right_end_of_window >= client_handles.userData.nTimeFrames
    right_over =  right_end_of_window - client_handles.userData.nTimeFrames;
    right_end_of_window = client_handles.userData.nTimeFrames;
end

starting_from = (left_end_of_window-right_over-1)*client_handles.userData.nProjectionsPerFrame + 1;
if starting_from <= 0
    starting_from = 1;
end

to            = (right_end_of_window+left_over)*client_handles.userData.nProjectionsPerFrame;
if to > client_handles.userData.totalNumberOfProjections
    to = client_handles.userData.totalNumberOfProjections;
end

FILTERED = true;
MODE = 0;
C = doBackProjection( client_handles, ...
    FILTERED,...
    starting_from,...
    to,...
    MODE,...
    noise_process);

end
