%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function [p,P_over_PC] = make_P_over_PC_ratio (...
    client_handles,...
    server_1_handles,...
    projectionNumber,...
    pc,...
    max_pc,...
    threshold,...
    noise_process,...
    LR_process)

i  = projectionNumber;

if ~noise_process
    HYPRcommonLoopProcess(client_handles,server_1_handles,i);
end

if noise_process
    if LR_process
        p  = iradon([client_handles.userData.g_noise(:,i) client_handles.userData.g_noise(:,i)],...
            [client_handles.userData.angles(i) client_handles.userData.angles(i)],...
            client_handles.userData.iradon_intepolation,...
            client_handles.userData.iradon_filter,...
            client_handles.userData.sz)/2;
        p  = filter_LR(p,client_handles);
    else
        p  = iradon([client_handles.userData.g_noise(:,i) client_handles.userData.g_noise(:,i)],...
            [client_handles.userData.angles(i) client_handles.userData.angles(i)],...
            'none',client_handles.userData.sz)/2;
    end
else
    if LR_process
        p  = iradon([client_handles.userData.g(:,i) client_handles.userData.g(:,i)],...
            [client_handles.userData.angles(i) client_handles.userData.angles(i)],...
            client_handles.userData.iradon_intepolation,...
            client_handles.userData.iradon_filter,...
            client_handles.userData.sz)/2;
        p  = filter_LR(p,client_handles);        
    else
        p  = iradon([client_handles.userData.g(:,i) client_handles.userData.g(:,i)],...
            [client_handles.userData.angles(i) client_handles.userData.angles(i)],...
            'none',...
            client_handles.userData.sz)/2;
    end
end

if ~noise_process
    if get(server_1_handles.turnOnProjectionUpdatesTag,'Value')==1
        axes(server_1_handles.currentPAxes);
        %imshow(imrotate( p,client_handles.userData.angles(i)),[ ]); %colorbar;
        imshow(p,[]); %colorbar;
        setXandTitleLabels(sprintf('P[%d],mean=%6.2f,max=%6.2f',i,mean(p(:)),max(p(:))),...
            '',...
            7,client_handles.userData.xlabelOffset);
        plot(server_1_handles.server_1_projection_on_P_axes,...
            client_handles.userData.g(:,projectionNumber));

        axes(server_1_handles.currentPCAxes);
        %imshow(imrotate( pc,client_handles.userData.angles(i)),[ ]); %colorbar;
        imshow( pc,[ ]); %colorbar;
        setXandTitleLabels(sprintf('PC[%d],mean=%6.2f,max=%6.2f',i,mean(pc(:)),max(pc(:))),'',...
            7,client_handles.userData.xlabelOffset);
        plot(server_1_handles.server_1_projection_on_PC_axes,...
            client_handles.userData.gc(:,projectionNumber));

    end
    %find the corresponding time frame image and display it
    if ~get(client_handles.client_user_projection_tag,'Value')==1
        userImages = client_handles.userData.userImages;
        display_image_with_correct_gray_scale(...
            server_1_handles.originalImage2Axes,...
            'originalImage2Axes',...
            userImages(:,:,i),...
            client_handles,...
            server_1_handles);
    end
end

p(p<0) = 0;                 %Add it 071508

%find the ratio and clean it up
if LR_process
   pc = filter_LR(pc,client_handles);
end

if get(client_handles.client_set_pc_zero_btn,'Value')==1
    P_over_PC                    = p./pc;
    P_over_PC(isnan(P_over_PC))  = 0;
    P_over_PC(isinf(P_over_PC )) = 0;
else
    set_value        = threshold*0.01*max_pc;
    pc(pc<set_value) = set_value;
    P_over_PC        = p./pc;
    P_over_PC(isnan(P_over_PC)) = 0;
end

end
