%****************************************************
%       Copyright (C) 2008 Nasser M. Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function varargout = nma_HYPR(varargin)
% NMA_HYPR M-file for nma_HYPR.fig
%
% by Nasser M. Abbasi
%
%      NMA_HYPR, by itself, creates a new NMA_HYPR or raises the existing
%      singleton*.
%
%      H = NMA_HYPR returns the handle to a new NMA_HYPR or the handle to
%      the existing singleton*.
%
%      NMA_HYPR('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in NMA_HYPR.M with the given input arguments.
%
%      NMA_HYPR('Property','Value',...) creates a new NMA_HYPR or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before nma_HYPR_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to nma_HYPR_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help nma_HYPR

% Last Modified by GUIDE v2.5 07-Aug-2008 18:45:48

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @nma_HYPR_OpeningFcn, ...
    'gui_OutputFcn',  @nma_HYPR_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before nma_HYPR is made visible.
function nma_HYPR_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to nma_HYPR (see VARARGIN)

% Choose default command line output for nma_HYPR

set(gcf,'UserData',[]);

handles.output = hObject;

set(handles.viewModeGroupTag,'SelectionChangeFcn',...
    @viewModeGroupTag_SelectionChangeFcn);
set(handles.selectSourceImageTag,'SelectionChangeFcn',...
    @selectSourceImageTag_SelectionChangeFcn);
set(handles.selectAlgorithmGroupTag,'SelectionChangeFcn',...
    @selectAlgorithmGroupTag_SelectionChangeFcn);
set(handles.noiseDistributionTag,'SelectionChangeFcn',...
    @noiseDistributionTag_SelectionChangeFcn);
set(handles.client_handling_zero_P_over_PC_group_tag,'SelectionChangeFcn',...
    @client_handling_zero_P_over_PC_group_tag_SelectionChangeFcn);

set(handles.client_LR_filter_group,'SelectionChangeFcn',...
    @client_LR_filter_group_SelectionChangeFcn);


stats_struct = struct('frame',0,...
    'noise_hypr_mean',0,...
    'noise_hypr_std',0,...
    'noise_hypr_mse',0,...
    'noise_C_mean',0,...
    'noise_C_std',0,...
    'noise_C_mse',0,...
    'hypr_mean',0,...
    'hypr_max',0,...
    'average_image_mean',0,...
    'average_image_max',0,...
    'RMSE',0,...
    'currentHYPRFrameMeanAbsDiff',0);

interrupt_state = struct('server2_state',0,...
    'server1_state',0,...
    'server_1_completed',1,...
    'server_1_completed_normal',0);

userData=struct('userImagesCreated',0,...
    'userImages',[],...
    'hypr_images_first_iteration',[],...
    'hypr_images_first_iteration_noise',[],...
    'hypr_images_last_iteration',[],...
    'hypr_images_last_iteration_noise',[],...
    'angles',[],...
    'maxGrayLevel',255,...
    'minGrayLevel',0,...
    'xValuesForTemporalProfile',[],...
    'yValuesForTemporalProfile',[],...
    'fid',-1,...
    'xlabelOffset',-9,...
    'seededRandomNumberGenerator',0,...
    'g',[],...
    'g_noise',[],...
    'gc',[],...
    'gc_noise',[],...
    'mean_noise_per_projection',[],...
    'sz',0,...  %image size
    'nTimeFrames',0,...
    'nProjectionsPerFrame',0,...
    'totalNumberOfProjections',0,...
    'g_length',0,...
    'averagedPSNR',0,... %for use by Iterative HYPR to make plot
    'averagedAbsDiff',0,... %for use by Iterative HYPR to make plot
    'stop',0,...
    'server_1_handle',0,...
    'server_2_handle',0,...
    'iradon_intepolation','',...
    'iradon_filter','',...
    'stats_struct',stats_struct,...
    'stats_array',[],...
    'LR_filter','',...
    'LR_filter_order',3);

m2 = sprintf('copyright by Nasser M. Abbasi');

%
% server1 state is  0=PAUSE,1=PLAY,2=move to next projection
%                  3=move to end of frame, 4=cancel

%
% server2 state is  0=PAUSE,1=PLAY,
%                   2=move to end of frame, 4=cancel and back to client


%
%  BOOT UP SERVER 1
%
userData.server_1_handle = openfig('server','new');
set(userData.server_1_handle , 'MenuBar', 'figure');  %to add zoom/unzomm/etc...
serverHandles = guihandles(userData.server_1_handle);
serverHandles.clientHandle = gcf;  %save client handle in server1

%save the server handles on the client side, so I do not
%have to reach out each time. (and do not have to change the code)
%handles = nma_addStruct( handles, serverHandles );      %nm062708
m1 = sprintf('HYPR simulator (Server 1). Version 1.6, April 29,2015 ');
set(userData.server_1_handle,'Name',[m1 m2]);
guidata(userData.server_1_handle,serverHandles);  %write it back
PARTIAL = false;
set_all_server1_navagation_buttons_to(serverHandles,PARTIAL,'off');

%
%  BOOT UP SERVER 2
%
userData.server_2_handle = openfig('server2','new');
set(userData.server_2_handle , 'toolbar', 'figure');  %to add zoom/unzomm/etc...
server2Handles = guihandles(userData.server_2_handle);
server2Handles.clientHandle = gcf;  %save client handle in server2
m1 = sprintf('HYPR simulator (Server 2). Version 1.6, April 29,2015 ');
set(userData.server_2_handle,'Name',[m1 m2]);
guidata(userData.server_2_handle,server2Handles);  %write it back
handles = nma_addStruct( handles, server2Handles );      %nm070308

% DONE WITH SERVERS stuff

%save the userData in the handles struct, easier.       %nma062408
handles.userData = userData;
handles.interrupt_state = interrupt_state;
m1 = sprintf('HYPR simulator (Client). Version 1.6, April 29,2015 ');
set(hObject,'Name',[m1 m2]);
guidata(hObject, handles);    %write it back

%
% attempt to open the log file.
%
handles      = guidata(hObject);
fid          = openLogFile(hObject);
userData.fid = fid;
guidata(hObject, handles);

%
% Center all windows
%
movegui(userData.server_2_handle, 'center');
movegui(userData.server_1_handle, 'center');
movegui(gcf, 'center');

%
% resest myself to clean any stuff from last run saved in fig file.
% strange.
%
resetBtnTag_Callback(hObject, [], handles)

% UIWAIT makes nma_HYPR wait for user response (see UIRESUME)
% uiwait(handles.figure1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function client_handling_zero_P_over_PC_group_tag_SelectionChangeFcn(hObject, eventdata)
handles = guidata(hObject);
h=get(hObject,'SelectedObject');
tag=get(h,'Tag');

switch tag
    case 'client_set_pc_zero_btn'
        set(handles.client_threshold_tag,'Enable','off');
    otherwise
        set(handles.client_threshold_tag,'Enable','on');
end

%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%
function client_LR_filter_group_SelectionChangeFcn(hObject, eventdata)
handles = guidata(hObject);
h=get(hObject,'SelectedObject');
tag=get(h,'Tag');

set_HYPR_LR_filters(tag,handles);

%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%
function set_HYPR_LR_filters(tag,handles)

switch tag
    case 'client_LR_wiener_tag'
        set(handles.client_filter_LR_order_median_tag,'Enable','off');
        set(handles.client_filter_LR_r_circle_tag,'Enable','off');
        set(handles.client_filter_LR_order_gaussian_tag,'Enable','off');
        set(handles.client_filter_LR_sigma_gaussian_tag,'Enable','off');
        set(handles.client_filter_LR_order_av_tag,'Enable','off');

        set(handles.client_filter_order_wiener_tag,'Enable','on');
    case 'client_LR_median_tag'
        set(handles.client_filter_order_wiener_tag,'Enable','off');
        set(handles.client_filter_LR_r_circle_tag,'Enable','off');
        set(handles.client_filter_LR_order_gaussian_tag,'Enable','off');
        set(handles.client_filter_LR_sigma_gaussian_tag,'Enable','off');
        set(handles.client_filter_LR_order_av_tag,'Enable','off');

        set(handles.client_filter_LR_order_median_tag,'Enable','on');

    case 'client_LR_circle_tag'
        set(handles.client_filter_order_wiener_tag,'Enable','off');
        set(handles.client_filter_LR_order_median_tag,'Enable','off');
        set(handles.client_filter_LR_order_gaussian_tag,'Enable','off');
        set(handles.client_filter_LR_sigma_gaussian_tag,'Enable','off');
        set(handles.client_filter_LR_order_av_tag,'Enable','off');

        set(handles.client_filter_LR_r_circle_tag,'Enable','on');

    case 'client_LR_gaussian_tag'
        set(handles.client_filter_order_wiener_tag,'Enable','off');
        set(handles.client_filter_LR_order_median_tag,'Enable','off');
        set(handles.client_filter_LR_r_circle_tag,'Enable','off');
        set(handles.client_filter_LR_order_av_tag,'Enable','off');

        set(handles.client_filter_LR_order_gaussian_tag,'Enable','on');
        set(handles.client_filter_LR_sigma_gaussian_tag,'Enable','on');

    case 'client_LR_average_tag'
        set(handles.client_filter_order_wiener_tag,'Enable','off');
        set(handles.client_filter_LR_order_median_tag,'Enable','off');
        set(handles.client_filter_LR_r_circle_tag,'Enable','off');
        set(handles.client_filter_LR_order_gaussian_tag,'Enable','off');
        set(handles.client_filter_LR_sigma_gaussian_tag,'Enable','off');

        set(handles.client_filter_LR_order_av_tag,'Enable','on');
end


%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%
function noiseDistributionTag_SelectionChangeFcn(hObject, eventdata)
handles = guidata(hObject);
h=get(hObject,'SelectedObject');
tag=get(h,'Tag');

switch tag
    case 'poissonBtnTag'

        set(handles.lambdaValueTag,'Enable','on');
        set(handles.normalMeanTag,'Enable','off');
        set(handles.normalSDTag,'Enable','off');
        set(handles.minUniformTag,'Enable','off');
        set(handles.maxUniformTag,'Enable','off');

    case 'normalBtnTag'
        set(handles.normalMeanTag,'Enable','on');
        set(handles.normalSDTag,'Enable','on');

        set(handles.lambdaValueTag,'Enable','off');
        set(handles.minUniformTag,'Enable','off');
        set(handles.maxUniformTag,'Enable','off');

    case 'uniformNoiseBtn'
        set(handles.minUniformTag,'Enable','on');
        set(handles.maxUniformTag,'Enable','on');

        set(handles.lambdaValueTag,'Enable','off');
        set(handles.normalMeanTag,'Enable','off');
        set(handles.normalSDTag,'Enable','off');
end

guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function viewModeGroupTag_SelectionChangeFcn(hObject, eventdata)
handles = guidata(hObject);
h=get(hObject,'SelectedObject');
tag=get(h,'Tag');

if strcmp(tag,'fullViewTag')
    set(handles.startAngleTag,'Enable','off');
    set(handles.endingAngleTag,'Enable','off');
else
    set(handles.startAngleTag,'Enable','on');
    set(handles.endingAngleTag,'Enable','on');
end

guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function selectSourceImageTag_SelectionChangeFcn(hObject, eventdata)

client_handles   = guidata(hObject);
server_1_handles = guidata(client_handles.userData.server_1_handle);

h=get(hObject,'SelectedObject');
tag=get(h,'Tag');

set(client_handles.client_point_impulse_radius_tag,'Enable','off');

switch tag
    case 'paperclipPhantomTag'
        %        set(handles.nTimeFramesTag,'String','64');
        %        set(handles.nProjectionsTag,'String','1');

        set(client_handles.nTimeFramesTag,'String','8');
        set(client_handles.nProjectionsTag,'String','8');
        set(client_handles.nTimeFramesTag,'Enable','off');
        set(client_handles.nProjectionsTag,'Enable','off');

        set(client_handles.fullViewTag,'Enable','off');
        set(client_handles.partialViewTag,'Enable','off');
        set(client_handles.startAngleTag,'Enable','off');
        set(client_handles.endingAngleTag,'Enable','off');
        set(server_1_handles.abs_error_server1_btn,'Enable','on');
        set(server_1_handles.absErrorDiffEnhanceTag,'Enable','on');


    case 'deltaPointSourceTag'
        set(client_handles.client_point_impulse_radius_tag,'Enable','on');

        set(client_handles.nTimeFramesTag,'String','16');
        set(client_handles.nProjectionsTag,'String','8');
        set(client_handles.nTimeFramesTag,'Enable','on');
        set(client_handles.nProjectionsTag,'Enable','on');

        set(client_handles.fullViewTag,'Enable','on');
        set(client_handles.partialViewTag,'Enable','on');

        if get(client_handles.fullViewTag,'Value')==1
            set(client_handles.startAngleTag,'Enable','off');
            set(client_handles.endingAngleTag,'Enable','off');
        else
            set(client_handles.startAngleTag,'Enable','on');
            set(client_handles.endingAngleTag,'Enable','on');
        end

        set(server_1_handles.abs_error_server1_btn,'Enable','on');
        set(server_1_handles.absErrorDiffEnhanceTag,'Enable','on');

    case 'client_user_projection_tag' %will read these below from the file
        set(client_handles.nTimeFramesTag,'Enable','off');
        set(client_handles.nProjectionsTag,'Enable','off');

        set(client_handles.fullViewTag,'Enable','off');
        set(client_handles.partialViewTag,'Enable','off');
        set(client_handles.startAngleTag,'Enable','off');
        set(client_handles.endingAngleTag,'Enable','off');

        set(server_1_handles.abs_error_server1_btn,'Enable','off');
        set(server_1_handles.abs_error_server1_btn,'Value',0);
        set(server_1_handles.intensity_profile_server1_btn,'Value',1);
        set(server_1_handles.intensity_profile_server1_btn,'Enable','off');
        set(server_1_handles.absErrorDiffEnhanceTag,'Enable','off');


    otherwise,
        % set(client_handles.nTimeFramesTag,'String','16');
        % set(client_handles.nProjectionsTag,'String','8');
        set(client_handles.nTimeFramesTag,'Enable','on');
        set(client_handles.nProjectionsTag,'Enable','on');

        set(client_handles.fullViewTag,'Enable','on');
        set(client_handles.partialViewTag,'Enable','on');

        if get(client_handles.fullViewTag,'Value')==1
            set(client_handles.startAngleTag,'Enable','off');
            set(client_handles.endingAngleTag,'Enable','off');
        else
            set(client_handles.startAngleTag,'Enable','on');
            set(client_handles.endingAngleTag,'Enable','on');
        end

        set(server_1_handles.abs_error_server1_btn,'Enable','on');
        set(server_1_handles.absErrorDiffEnhanceTag,'Enable','on');
        set(server_1_handles.intensity_profile_server1_btn,'Enable','on');
end

set(server_1_handles.statusTag,'String','Ready...');
%guidata(hObject,handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function selectAlgorithmGroupTag_SelectionChangeFcn(hObject, eventdata)

handles = guidata(hObject);
h=get(hObject,'SelectedObject');
tag=get(h,'Tag');

if strcmp(tag,'wrightHuangHYPRTag') ||strcmp(tag ,'originalHYPRTag')||...
        strcmp(tag ,'client_FBP_btn')
    set(handles.nIterationsForIHYPRTag,'Enable','off');
    set_all_LR(handles,'off');
    if strcmp(tag ,'client_FBP_btn')
        set(handles.client_sliding_window_tag,'Enable','off');
        set(handles.client_sliding_window_size_tag,'Enable','off');
    else
        set(handles.client_sliding_window_tag,'Enable','on');
        if get(handles.client_sliding_window_tag,'Value')==1
            set(handles.client_sliding_window_size_tag,'Enable','on');
        end
    end
else
    set(handles.nIterationsForIHYPRTag,'Enable','on');

    set(handles.client_sliding_window_tag,'Enable','on');
    if get(handles.client_sliding_window_tag,'Value')==1
        set(handles.client_sliding_window_size_tag,'Enable','on');
    end
end

set_all_LR(handles,'off');
set(handles.lrHYPRBtn,'Value',0);

guidata(hObject, handles);

%%%%%%%%%%%%%
%
%%%%%%%%%%%%
function     set_all_LR(handles,to)

set(handles.client_LR_wiener_tag,'Enable',to);
set(handles.client_filter_order_wiener_tag,'Enable',to);
set(handles.client_LR_median_tag,'Enable',to);
set(handles.client_filter_LR_order_median_tag,'Enable',to);
set(handles.client_LR_circle_tag,'Enable',to);
set(handles.client_filter_LR_r_circle_tag,'Enable',to);
set(handles.client_LR_gaussian_tag,'Enable',to);
set(handles.client_filter_LR_order_gaussian_tag,'Enable',to);
set(handles.client_filter_LR_sigma_gaussian_tag,'Enable',to);
set(handles.client_LR_average_tag,'Enable',to);
set(handles.client_filter_LR_order_av_tag,'Enable',to);

%%%%%%%%%
%
%%%%%%%%%%
function lrHYPRBtn_Callback(hObject, eventdata, handles)
set_all_LR(handles,'on');

set(handles.client_sliding_window_tag,'Enable','on');
if get(handles.client_sliding_window_tag,'Value')==1
    set(handles.client_sliding_window_size_tag,'Enable','on');
end

set(handles.nIterationsForIHYPRTag,'Enable','off');
set(handles.wrightHuangHYPRTag,'Value',0);
set(handles.originalHYPRTag,'Value',0);
set(handles.client_FBP_btn,'Value',0);
set(handles.IHYPRTag,'Value',0);
set(handles.IWHYPRTag,'Value',0);

if get(handles.client_LR_wiener_tag,'Value')==1
    set_HYPR_LR_filters('client_LR_wiener_tag',handles);
elseif get(handles.client_LR_median_tag,'Value')==1
    set_HYPR_LR_filters('client_LR_median_tag',handles);
elseif get(handles.client_LR_circle_tag,'Value')==1
    set_HYPR_LR_filters('client_LR_circle_tag',handles);
elseif get(handles.client_LR_gaussian_tag,'Value')==1
    set_HYPR_LR_filters('client_LR_gaussian_tag',handles);
else
    set_HYPR_LR_filters('client_LR_average_tag',handles);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Outputs from this function are returned to the command line.
function varargout = nma_HYPR_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function startAngleTag_Callback(hObject, eventdata, handles)
% hObject    handle to startAngleTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of startAngleTag as text
%        str2double(get(hObject,'String')) returns contents of startAngleTag as a double

v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for starting angle [%s]',v),'modal'));
    return;
end

if v<0
    uiwait(errordlg(sprintf('starting angle must be >= 0 degrees  [%d]',v),'modal'));
    return;
end

if v>=180
    uiwait(errordlg(sprintf('starting angle must be < 180 degrees  [%d]',v),'modal'));
    return;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function startAngleTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to startAngleTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function endingAngleTag_Callback(hObject, eventdata, handles)
% hObject    handle to endingAngleTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of endingAngleTag as text
%        str2double(get(hObject,'String')) returns contents of endingAngleTag as a double

v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for ending angle [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value of ending angle [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('ending angle must be > 0 degrees  [%d]',v),'modal'));
    return;
end

if v>180
    uiwait(errordlg(sprintf('ending angle must be <= 180 degrees  [%d]',v),'modal'));
    return;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function endingAngleTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to endingAngleTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nTimeFramesTag_Callback(hObject, eventdata, handles)
% hObject    handle to nTimeFramesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nTimeFramesTag as text
%        str2double(get(hObject,'String')) returns contents of nTimeFramesTag as a double

v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for number of time frames [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value of number of time frames [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of time frames must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('number of time frames must integer  [%f]',v),'modal'));
    return;
end

% set it initially to some ok value. User can change this any way
switch v
    case 1
        list_value = 1;
    case {2,3,4,5}
        list_value = 2;
    case {6,7}
        list_value = 3;
    otherwise
        list_value = 4;
end

set(handles.client_sliding_window_size_tag,...
    'String',get_sliding_window_sizes(v),...
    'Value',list_value);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function nTimeFramesTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nTimeFramesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function timeFrameToProcessTag_Callback(hObject, eventdata, handles)
% hObject    handle to timeFrameToProcessTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of timeFrameToProcessTag as text
%        str2double(get(hObject,'String')) returns contents of timeFrameToProcessTag as a double

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function timeFrameToProcessTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to timeFrameToProcessTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in wrightPaperDiskTag.
function wrightPaperDiskTag_Callback(hObject, eventdata, handles)
% hObject    handle to wrightPaperDiskTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of wrightPaperDiskTag

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in movingDiskUpDownTag.
function movingDiskUpDownTag_Callback(hObject, eventdata, handles)
% hObject    handle to movingDiskUpDownTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of movingDiskUpDownTag

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in originalHYPRTag.
function originalHYPRTag_Callback(hObject, eventdata, handles)
% hObject    handle to originalHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of originalHYPRTag

handles = guidata(hObject);

set(handles.nIterationsForIHYPRTag,'Enabled','off');
guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in wrightHuangHYPRTag.
function wrightHuangHYPRTag_Callback(hObject, eventdata, handles)
% hObject    handle to wrightHuangHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of wrightHuangHYPRTag

handles = guidata(hObject);
set(handles.nIterationsForIHYPRTag,'Enabled','off');
guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in IHYPRTag.
function IHYPRTag_Callback(hObject, eventdata, handles)
% hObject    handle to IHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of IHYPRTag

handles = guidata(hObject);
set(handles.nIterationsForIHYPRTag,'Enabled','on');
guidata(hObject, handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in IWHYPRTag.
function IWHYPRTag_Callback(hObject, eventdata, handles)
% hObject    handle to IWHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of IWHYPRTag

handles = guidata(hObject);
set(handles.nIterationsForIHYPRTag,'Enabled','on');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nIterationsForIHYPRTag_Callback(hObject, eventdata, handles)
% hObject    handle to nIterationsForIHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nIterationsForIHYPRTag as text
%        str2double(get(hObject,'String')) returns contents of nIterationsForIHYPRTag as a double

v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for number of HYPR iterations [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for number of HYPR iterations [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of HYPR iterations must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('number of HYPR iterations must integer  [%f]',v),'modal'));
    return;
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function nIterationsForIHYPRTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nIterationsForIHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function nProjectionsTag_Callback(hObject, eventdata, handles)
% hObject    handle to nProjectionsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of nProjectionsTag as text
%        str2double(get(hObject,'String')) returns contents of nProjectionsTag as a double

v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for number of projections [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for number of projections [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of projections must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('number of projections must integer  [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of projections must be > 0  [%d]',v),'modal'));
    return;
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function nProjectionsTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to nProjectionsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function statusTag_Callback(hObject, eventdata, handles)
% hObject    handle to statusTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of statusTag as text
%        str2double(get(hObject,'String')) returns contents of statusTag as a double

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function statusTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to statusTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in resetBtnTag.
function resetBtnTag_Callback(hObject, eventdata, handles)
% hObject    handle to resetBtnTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if ~isempty(handles.userData)
    handles.userData.userImagesCreated = 0;

    msg = sprintf('%s\n','Enter RESET ...');
    updateLogFile(msg,handles.userData.fid);

    handles.userData.userImages = [];
    if handles.userData.fid ~= -1
        fclose(handles.userData.fid);
        handles.userData.fid = -1;
    end

    fid          = openLogFile(hObject);
    handles.userData.fid = fid;
end

set(handles.generateTemporalImagesTag,'Enable','on');
set(handles.generateHYPRBtnTag,'Enable','off');
set(handles.playback_btn,'Enable','off');

set_image_selection_buttons(handles,'on');

server_1_handles = guidata(handles.userData.server_1_handle);
set(server_1_handles.statusTag,'String','Ready for new images...');

if get(handles.paperclipPhantomTag,'Value')==1 || ...
        get(handles.client_user_projection_tag,'Value')==1
    set(handles.nTimeFramesTag,'Enable','off');
    set(handles.nProjectionsTag,'Enable','off');
else
    set(handles.nTimeFramesTag,'Enable','on');
    set(handles.nProjectionsTag,'Enable','on');
end

resetLastAlgorithmAxes(server_1_handles)
clearAllStatistics(server_1_handles);
PARTIAL=false;
server_1_handles = guidata(handles.userData.server_1_handle);
set_all_server1_navagation_buttons_to(server_1_handles,PARTIAL,'off');
set(server_1_handles.server_1_generate_HYPR_frames_btn,'Enable','off');

% Update handles structure
guidata(hObject, handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in separateFiguresTag.
function separateFiguresTag_Callback(hObject, eventdata, handles)
% hObject    handle to separateFiguresTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of separateFiguresTag


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function PSNRTag_Callback(hObject, eventdata, handles)
% hObject    handle to PSNRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of PSNRTag as text
%        str2double(get(hObject,'String')) returns contents of PSNRTag as a double

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function PSNRTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to PSNRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function meanHYPRTag_Callback(hObject, eventdata, handles)
% hObject    handle to meanHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of meanHYPRTag as text
%        str2double(get(hObject,'String')) returns contents of meanHYPRTag as a double

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function meanHYPRTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to meanHYPRTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function imageFrameMeanTag_Callback(hObject, eventdata, handles)
% hObject    handle to imageFrameMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of imageFrameMeanTag as text
%        str2double(get(hObject,'String')) returns contents of imageFrameMeanTag as a double

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function imageFrameMeanTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to imageFrameMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%
function logFileNameTag_Callback(hObject, eventdata, handles)
% hObject    handle to logFileNameTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of logFileNameTag as text
%        str2double(get(hObject,'String')) returns contents of logFileNameTag as a double

%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function logFileNameTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to logFileNameTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function relErrorTag_Callback(hObject, eventdata, handles)
% hObject    handle to relErrorTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of relErrorTag as text
%        str2double(get(hObject,'String')) returns contents of relErrorTag as a double

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function relErrorTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to relErrorTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in fastUpdateTag.
function fastUpdateTag_Callback(hObject, eventdata, handles)
% hObject    handle to fastUpdateTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of fastUpdateTag

%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in turnOnProjectionUpdatesTag.
function turnOnProjectionUpdatesTag_Callback(hObject, eventdata, handles)
% hObject    handle to turnOnProjectionUpdatesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of turnOnProjectionUpdatesTag


%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in addNoiseTag.
function addNoiseTag_Callback(hObject, eventdata, handles)
% hObject    handle to addNoiseTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of addNoiseTag
handles  = guidata(hObject);

%fix to reset to the way it was, but too lazy now
if get(hObject,'Value')==1
    set(handles.poissonBtnTag,'Enable','on');
    set(handles.normalBtnTag,'Enable','on');
    set(handles.uniformNoiseBtn,'Enable','on');

    set(handles.poissonBtnTag,'Value',1);
    set(handles.lambdaValueTag,'Enable','on');
    set(handles.normalBtnTag,'Value',0);
    set(handles.uniformNoiseBtn,'Value',0);

    set(handles.normalMeanTag,'Enable','off');
    set(handles.normalSDTag,'Enable','off');
    set(handles.minUniformTag,'Enable','off');
    set(handles.maxUniformTag,'Enable','off');

else
    set(handles.poissonBtnTag,'Enable','off');
    set(handles.normalBtnTag,'Enable','off');
    set(handles.normalMeanTag,'Enable','off');
    set(handles.normalSDTag,'Enable','off');
    set(handles.lambdaValueTag,'Enable','off');
    set(handles.minUniformTag,'Enable','off');
    set(handles.maxUniformTag,'Enable','off');
    set(handles.uniformNoiseBtn,'Enable','off');

end
guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%
function lambdaValueTag_Callback(hObject, eventdata, handles)
% hObject    handle to lambdaValueTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of lambdaValueTag as text
%        str2double(get(hObject,'String')) returns contents of lambdaValueTag as a double


% --- Executes during object creation, after setting all properties.
function lambdaValueTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to lambdaValueTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%
function normalMeanTag_Callback(hObject, eventdata, handles)
% hObject    handle to normalMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of normalMeanTag as text
%        str2double(get(hObject,'String')) returns contents of normalMeanTag as a double
v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value mean of normal distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value mean of normal distribution [%f]',v),'modal'));
    return;
end

%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%
function normalSDTag_Callback(hObject, eventdata, handles)
% hObject    handle to normalMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of normalMeanTag as text
%        str2double(get(hObject,'String')) returns contents of normalMeanTag as a double
v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for Standard deviation percentage of normal distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for standard deviation percentage of normal distribution [%f]',v),'modal'));
    return;
end

if v<0
    uiwait(errordlg(sprintf('Standard deviation percentage of normal distribution must be >=0 [%f]',v),'modal'));
    return;
end

if v>100
    uiwait(errordlg(sprintf('Standard deviation percentage of normal distribution must be <=100 [%f]',v),'modal'));
    return;
end


% --- Executes during object creation, after setting all properties.
function normalMeanTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to normalMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



%%%%%%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in movingDiskDiagonalTag.
function movingDiskDiagonalTag_Callback(hObject, eventdata, handles)
% hObject    handle to movingDiskDiagonalTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of movingDiskDiagonalTag



%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function relErrorMeanTag_Callback(hObject, eventdata, handles)
% hObject    handle to relErrorMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of relErrorMeanTag as text
%        str2double(get(hObject,'String')) returns contents of relErrorMeanTag as a double

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function relErrorMeanTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to relErrorMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function relRMSEMeanTag_Callback(hObject, eventdata, handles)
% hObject    handle to relRMSEMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of relRMSEMeanTag as text
%        str2double(get(hObject,'String')) returns contents of relRMSEMeanTag as a double

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function relRMSEMeanTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to relRMSEMeanTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function currentFrameNumberTag_Callback(hObject, eventdata, handles)
% hObject    handle to currentFrameNumberTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of currentFrameNumberTag as text
%        str2double(get(hObject,'String')) returns contents of currentFrameNumberTag as a double

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function currentFrameNumberTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to currentFrameNumberTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function minUniformTag_Callback(hObject, eventdata, handles)
% hObject    handle to minUniformTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of minUniformTag as text
%        str2double(get(hObject,'String')) returns contents of minUniformTag as a double
v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for minumum of uniform distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for minumum of uniform distribution [%f]',v),'modal'));
    return;
end

the_max = str2double(get(handles.maxUniformTag,'String'));
if v>=the_max
    uiwait(errordlg(sprintf('minumum of uniform distribution [%f] has to be less than the maximum value',v),'modal'));
    return;
end

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function minUniformTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to minUniformTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function maxUniformTag_Callback(hObject, eventdata, handles)
% hObject    handle to maxUniformTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of maxUniformTag as text
%        str2double(get(hObject,'String')) returns contents of maxUniformTag as a double

v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for maximum of uniform distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for maximum of uniform distribution [%f]',v),'modal'));
    return;
end

the_min = str2double(get(handles.minUniformTag,'String'));
if v<=the_min
    uiwait(errordlg(sprintf('maximum of uniform distribution [%f] has to be larger than the minimum value',v),'modal'));
    return;
end


%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function maxUniformTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to maxUniformTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes on button press in turnOnNoiseUpdatesTag.
function turnOnNoiseUpdatesTag_Callback(hObject, eventdata, handles)
% hObject    handle to turnOnNoiseUpdatesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of turnOnNoiseUpdatesTag



%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function currentFrameMeanAbsErrorTag_Callback(hObject, eventdata, handles)
% hObject    handle to currentFrameMeanAbsErrorTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of currentFrameMeanAbsErrorTag as text
%        str2double(get(hObject,'String')) returns contents of currentFrameMeanAbsErrorTag as a double


%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function currentFrameMeanAbsErrorTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to currentFrameMeanAbsErrorTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function runningMeanAbsDiffTag_Callback(hObject, eventdata, handles)
% hObject    handle to runningMeanAbsDiffTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of runningMeanAbsDiffTag as text
%        str2double(get(hObject,'String')) returns contents of runningMeanAbsDiffTag as a double

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
% --- Executes during object creation, after setting all properties.
function runningMeanAbsDiffTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to runningMeanAbsDiffTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function compositeEnhanceTag_Callback(hObject, eventdata, handles)

%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%
function absErrorDiffEnhanceTag_Callback(hObject, eventdata, handles)


%%%%%%%%%%%%%%%%%%
%
% SERVER 2 CALLBACKS
%
%%%%%%%%%%%%%%%%

%
% server2 state is  0=PAUSE,1=PLAY, 2=next frame, 3=cancel
%

function server2_stop_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server2_state=3;
guidata(handles.clientHandle,clientHandles);
set(handles.server_2_pause_btn,'Enable','off');
set(handles.server_2_play_btn,'Enable','off');
set(handles.server_2_move_one_frame_btn,'Enable','off');
figure(clientHandles.figure1);


function server2_pause_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server2_state=0;
guidata(handles.clientHandle,clientHandles);

function server2_play_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server2_state=1;
guidata(handles.clientHandle,clientHandles);

function server2_move_one_frame_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server2_state=2;
guidata(handles.clientHandle,clientHandles);

function server2_reply_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
playback_btn_Callback(clientHandles.figure1, [], []);


% --- Executes on button press in playback_btn on client window
function playback_btn_Callback(hObject, eventdata, handles)
% hObject    handle to playback_btn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%
% server2 state is  0=PAUSE,1=PLAY, 2=next frame, 3=cancel
%
PAUSE      = 0;
PLAY       = 1;
NEXT_FRAME = 2;
CANCEL     = 3;

client_handles   = guidata(hObject);
server_2_handles = guidata(client_handles.userData.server_2_handle);

if isempty(client_handles.userData.hypr_images_last_iteration)
    return;
end

if isempty(client_handles.userData.hypr_images_first_iteration)
    return;
end

if size(client_handles.userData.hypr_images_last_iteration,3) ~= ...
        size(client_handles.userData.hypr_images_first_iteration,3)
    return;  %something is wrong. run away
end

set(server_2_handles.server_2_pause_btn,'Enable','on');
set(server_2_handles.server_2_play_btn,'Enable','on');
set(server_2_handles.server_2_move_one_frame_btn,'Enable','on');
set(server_2_handles.server_2_stop_btn,'Enable','on');

cla(server_2_handles.server_2_original_image_AXES,'reset');
cla(server_2_handles.server2_playback_final_AXES,'reset');
cla(server_2_handles.server2_playback_first_AXES,'reset');

client_handles.interrupt_state.server2_state = PAUSE;
guidata(hObject,client_handles);

projection_number = 1;
frame_number      = 1;
figure(server_2_handles.figure_server_2 );

while client_handles.interrupt_state.server2_state ~= CANCEL && ...
        projection_number<client_handles.userData.totalNumberOfProjections

    client_handles   = guidata(hObject);
    switch client_handles.interrupt_state.server2_state
        case CANCEL
            set(server_2_handles.server_2_pause_btn,'Enable','off');
            set(server_2_handles.server_2_play_btn,'Enable','off');
            set(server_2_handles.server_2_move_one_frame_btn,'Enable','off');
            figure(client_handles.figure1);

        case PAUSE
            pause(.1);

        case NEXT_FRAME
            play_one_frame(client_handles,projection_number,frame_number);
            projection_number = projection_number + client_handles.userData.nProjectionsPerFrame;
            frame_number = frame_number + 1;
            client_handles.interrupt_state.server2_state = PAUSE;
            guidata(hObject,client_handles);

        case PLAY
            play_one_frame(client_handles,projection_number,frame_number);
            frame_number = frame_number + 1;
            projection_number = projection_number + client_handles.userData.nProjectionsPerFrame;
            if get(server_2_handles.server_2_fast_speed_tag,'Value')==0
                pause(.5);
            end
    end
end

%%%%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%
function play_one_frame(client_handles,projection_number,frame_number)

for k=projection_number:projection_number+client_handles.userData.nProjectionsPerFrame-1
    image = client_handles.userData.userImages(:,:,k);
    axes(client_handles.server_2_original_image_AXES);
    if get(client_handles.phantomBtn,'Value')==1 || get(client_handles.paperclipPhantomTag,'Value')==1
        imshow(image);
    else
        imshow(image,[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
    end
    title(client_handles.server_2_original_image_AXES,...
        sprintf('Corresponding original image at time %d',k));
end

image = client_handles.userData.hypr_images_first_iteration(:,:,frame_number);
axes(client_handles.server2_playback_first_AXES);
if get(client_handles.phantomBtn,'Value')==1 || get(client_handles.paperclipPhantomTag,'Value')==1
    imshow(image);
else
    imshow(image,[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
end

%add_colorbar(client_handles.server2_playback_first_AXES,0.038);

title(client_handles.server2_playback_first_AXES,...
    'sequence of HYPR frame, before iteration');
xlabel(client_handles.server2_playback_first_AXES,sprintf('HYPR frame %d',frame_number));

axes(client_handles.server2_playback_final_AXES);
image = client_handles.userData.hypr_images_last_iteration(:,:,frame_number);
if get(client_handles.phantomBtn,'Value')==1 || get(client_handles.paperclipPhantomTag,'Value')==1
    imshow(image);
else
    imshow(image,[client_handles.userData.minGrayLevel client_handles.userData.maxGrayLevel]);
end

%add_colorbar(client_handles.server2_playback_final_AXES,0.038);

title(client_handles.server2_playback_final_AXES,...
    'sequence of HYPR frame, last iteration');
xlabel(client_handles.server2_playback_final_AXES,...
    sprintf('HYPR frame %d',frame_number));


%%%%%%%%%%%%%%%%%%
% Following are callbacks from server 1
%
% 'server1_state'
%
% server1 state is  0=PAUSE,1=PLAY,2=move to next projection
%                  3=move to end of frame, 4=cancel
%
%
%%%%%%%%%%%%%%%%%%
function pause_server1_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server1_state=0;
guidata(handles.clientHandle,clientHandles);

%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%
function play_server1_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server1_state=1;
guidata(handles.clientHandle,clientHandles);
%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%
function advance_to_next_projection_server1_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server1_state=2;
guidata(handles.clientHandle,clientHandles);
%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%
function advance_to_end_of_current_time_frame_server1_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server1_state=3;
guidata(handles.clientHandle,clientHandles);
%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%
function cancel_and_back_to_client_server1_btn_Callback(hObject, eventdata, handles)
clientHandles = guidata(handles.clientHandle);
clientHandles.interrupt_state.server1_state=4;
guidata(handles.clientHandle,clientHandles);
if clientHandles.interrupt_state.server_1_completed==1
    figure(clientHandles.figure1);
end
set(clientHandles.resetBtnTag,'Enable','on');

%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%
function server1_abs_error_btn_Callback(hObject, eventdata, handles)
set(handles.absErrorDiffEnhanceTag,'Enable','on');
set(handles.server_1_horiz_section_view,'Enable','off');
set(handles.server_1_add_PC_and_PC_to_view_tag,'Enable','off');

%%%%%%%%%%%%%%%%
%
%%%%%%%%%%%%%%%%%
function server1_intensity_btn_Callback(hObject, eventdata, handles)
set(handles.absErrorDiffEnhanceTag,'Enable','off');
set(handles.server_1_horiz_section_view,'Enable','on');
set(handles.server_1_add_PC_and_PC_to_view_tag,'Enable','on');

%%%%%%%%%%%%
%
%%%%%%%%%%%%%%
function server_1_generate_HYPR_frames_btn_Callback(hObject, eventdata, handles)
client_handles = guidata(handles.clientHandle);
generateHYPRBtnTag_Callback(client_handles.figure1, eventdata, handles);

%%%%%%%%%%%%%%%%%%%
% END OF MY FILE
%%%%%%%%%%%%%%%%%%




% --- Executes on button press in client_FBP_btn.
function client_FBP_btn_Callback(hObject, eventdata, handles)
% hObject    handle to client_FBP_btn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of client_FBP_btn

function client_threshold_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_threshold_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of client_threshold_tag as text
%        str2double(get(hObject,'String')) returns contents of client_threshold_tag as a double
v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for threshold percentage [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for threshold percentage [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('Threshold percentage must be > 0  [%f]',v),'modal'));
    return;
end

if v>100
    uiwait(errordlg(sprintf('Threshold percentage must be <= 100  [%f]',v),'modal'));
    return;
end

% --- Executes during object creation, after setting all properties.
function client_threshold_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_threshold_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function client_point_impulse_radius_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_point_impulse_radius_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of client_point_impulse_radius_tag as text
%        str2double(get(hObject,'String')) returns contents of client_point_impulse_radius_tag as a double
v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for impulse radius [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for impulse radius [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('impulse radius must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('impulse radius must be integer  [%f]',v),'modal'));
    return;
end


% --- Executes during object creation, after setting all properties.
function client_point_impulse_radius_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_point_impulse_radius_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on selection change in client_fliter_for_LR_tag.
function client_lambda_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_fliter_for_LR_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns client_fliter_for_LR_tag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from client_fliter_for_LR_tag
v = str2double(get(hObject,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for lambda [%s] for poisson distribution',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for lambda [%f] for poisson distribution',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('lambda > 0  [%d]',v),'modal'));
    return;
end



% --- Executes on selection change in client_fliter_for_LR_tag.
function client_fliter_for_LR_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_fliter_for_LR_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns client_fliter_for_LR_tag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from client_fliter_for_LR_tag


% --- Executes during object creation, after setting all properties.
function client_fliter_for_LR_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_fliter_for_LR_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in client_filter_LR_order_av_tag.
function client_filter_LR_order_av_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_order_av_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns client_filter_LR_order_av_tag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from client_filter_LR_order_av_tag


% --- Executes during object creation, after setting all properties.
function client_filter_LR_order_av_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_order_av_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on selection change in client_filter_LR_order_gaussian_tag.
function client_filter_LR_order_gaussian_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_order_gaussian_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns client_filter_LR_order_gaussian_tag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from client_filter_LR_order_gaussian_tag


% --- Executes during object creation, after setting all properties.
function client_filter_LR_order_gaussian_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_order_gaussian_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function client_filter_LR_sigma_gaussian_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_sigma_gaussian_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of client_filter_LR_sigma_gaussian_tag as text
%        str2double(get(hObject,'String')) returns contents of client_filter_LR_sigma_gaussian_tag as a double


% --- Executes during object creation, after setting all properties.
function client_filter_LR_sigma_gaussian_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_sigma_gaussian_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function client_filter_LR_r_circle_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_r_circle_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of client_filter_LR_r_circle_tag as text
%        str2double(get(hObject,'String')) returns contents of client_filter_LR_r_circle_tag as a double


% --- Executes during object creation, after setting all properties.
function client_filter_LR_r_circle_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_r_circle_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in client_filter_LR_order_median_tag.
function client_filter_LR_order_median_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_order_median_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns client_filter_LR_order_median_tag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from client_filter_LR_order_median_tag


% --- Executes during object creation, after setting all properties.
function client_filter_LR_order_median_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_filter_LR_order_median_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in client_filter_order_wiener_tag.
function client_filter_order_wiener_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_filter_order_wiener_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns client_filter_order_wiener_tag contents as cell array
%        contents{get(hObject,'Value')} returns selected item from client_filter_order_wiener_tag


% --- Executes during object creation, after setting all properties.
function client_filter_order_wiener_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_filter_order_wiener_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on button press in client_sliding_window_tag.
function client_sliding_window_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_sliding_window_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of client_sliding_window_tag
v=get(handles.client_sliding_window_tag,'Value');
if v==0
    set(handles.client_sliding_window_size_tag,'Enable','off');
else
    set(handles.client_sliding_window_size_tag,'Enable','on');

    number_of_time_frames = str2double(get(handles.nTimeFramesTag,'String'));
    if ~isnumeric(number_of_time_frames)
        uiwait(errordlg(sprintf('invalid value for number of time frames [%s]',number_of_time_frames),'modal'));
        return;
    end

    if isnan(number_of_time_frames)
        uiwait(errordlg(sprintf('invalid value of number of time frames [%f]',number_of_time_frames),'modal'));
        return;
    end

    if number_of_time_frames<=0
        uiwait(errordlg(sprintf('number of time frames must be > 0  [%d]',number_of_time_frames),'modal'));
        return;
    end

    if ~(ceil(number_of_time_frames) == floor(number_of_time_frames))
        uiwait(errordlg(sprintf('number of time frames must integer  [%f]',number_of_time_frames),'modal'));
        return;
    end

    % set it initially to some ok value. User can change this any way
    switch number_of_time_frames
        case 1
            list_value = 1;
        case {2,3,4,5}
            list_value = 2;
        case {6,7}
            list_value = 3;
        otherwise
            list_value = 4;
    end

    set(handles.client_sliding_window_size_tag,...
         'String',get_sliding_window_sizes(number_of_time_frames),...
         'Value',list_value);    
end


function client_sliding_window_size_tag_Callback(hObject, eventdata, handles)
% hObject    handle to client_sliding_window_size_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of client_sliding_window_size_tag as text
%        str2double(get(hObject,'String')) returns contents of client_sliding_window_size_tag as a double


% --- Executes during object creation, after setting all properties.
function client_sliding_window_size_tag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to client_sliding_window_size_tag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


