%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function running_psnr_vector= nma_update_PSNR...
    (HYPR_frame,hypr_frame_number,client_handles,server_1_handles,running_psnr_vector)
%
% updates the PSNR plot with stats for current HYPR frame
% by Nasser Abbasi 062908

%find the range of user images

starting_image_number = ((hypr_frame_number-1)*client_handles.userData.nProjectionsPerFrame)+1;
user_images           = client_handles.userData.userImages;
psnr_total            = 0;
k                     = starting_image_number;

for i = 1:client_handles.userData.nProjectionsPerFrame
    current_rms = mean(mean((HYPR_frame - user_images(:,:,k)).^2));

    %per discussion with Dr Pineda, normalize RMSE by the max intensity
    %of the user image, intead of maximum gray level, which used to be
    %255

    max_intensity = max(max(user_images(:,:,k)));
    %psnr_total   = psnr_total + 20*log10(max_intensity/sqrt(current_rms));
    if max_intensity > 0
        psnr_total    = psnr_total + (sqrt(current_rms)/max_intensity) * 100;
    end
    k = k + 1;
end

%plot stuff
mean_psnr = psnr_total / client_handles.userData.nProjectionsPerFrame;
plot(server_1_handles.PSNRAxes,hypr_frame_number,mean_psnr,'.');
title(server_1_handles.PSNRAxes,'relative RMSE per HYPR frame','FontSize', 8); 
xlabel(server_1_handles.PSNRAxes,'hypr frame number');
ylabel(server_1_handles.PSNRAxes,'% RMSE');
if client_handles.userData.nTimeFrames==1
    xlim(server_1_handles.PSNRAxes,[1,2]);
else
    xlim(server_1_handles.PSNRAxes,[1,client_handles.userData.nTimeFrames]);
end

hold(server_1_handles.PSNRAxes,'on');
running_psnr_vector(hypr_frame_number) = mean_psnr;
plot(server_1_handles.PSNRAxes,1:hypr_frame_number,...
    running_psnr_vector(1:hypr_frame_number));

%that was fun


