%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************

function update_image_statistics(image_name,...
    the_image,...
    hObject)

client_handles   = guidata(hObject);
server_1_handles = guidata(client_handles.userData.server_1_handle);

mean_image = mean(the_image(:));
max_image  = max( the_image(:) );

switch image_name
    case 'HYPR'
        set(server_1_handles.server_1_mean_HYPR_tag,'String',...
            sprintf('%5.4f',mean_image));
        set(server_1_handles.server_1_max_HYPR_tag,'String',sprintf('%5.4f',max_image));
        
        client_handles.userData.stats_struct.hypr_mean = mean_image;
        client_handles.userData.stats_struct.hypr_max  = max_image;

    case 'MEAN_TRUE_IMAGE'
        set(server_1_handles.server_1_mean_image_tag,'String',sprintf('%5.4f',mean_image));
        set(server_1_handles.server_1_max_image_tag,'String',sprintf('%5.4f',max_image));

        client_handles.userData.stats_struct.average_image_mean = mean_image;
        client_handles.userData.stats_struct.average_image_max  = max_image;       
end

guidata(hObject,client_handles);

end