%****************************************************
%       Copyright (C) 2008 Nasser Abbasi
%  Free to use and modify for academic and research only
%***************************************************
function is_success = verify_all_UI_input(hObject)
is_success = false;
client_handles   = guidata(hObject);

v = str2double(get(client_handles.startAngleTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for starting angle [%s]',v),'modal'));
    return;
end

if v<0
    uiwait(errordlg(sprintf('starting angle must be >= 0 degrees  [%d]',v),'modal'));
    return;
end

if v>=180
    uiwait(errordlg(sprintf('starting angle must be < 180 degrees  [%d]',v),'modal'));
    return;
end

%--------

v = str2double(get(client_handles.endingAngleTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for ending angle [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value of ending angle [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('ending angle must be > 0 degrees  [%d]',v),'modal'));
    return;
end

if v>180
    uiwait(errordlg(sprintf('ending angle must be <= 180 degrees  [%d]',v),'modal'));
    return;
end

%----------

v = str2double(get(client_handles.nTimeFramesTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for number of time frames [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value of number of time frames [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of time frames must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('number of time frames must integer  [%f]',v),'modal'));
    return;
end

%-------------

v = str2double(get(client_handles.nIterationsForIHYPRTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for number of HYPR iterations [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for number of HYPR iterations [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of HYPR iterations must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('number of HYPR iterations must integer  [%f]',v),'modal'));
    return;
end


%---------

v = str2double(get(client_handles.nProjectionsTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for number of projections [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for number of projections [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of projections must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('number of projections must integer  [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('number of projections must be > 0  [%d]',v),'modal'));
    return;
end

%----------------

v = str2double(get(client_handles.normalMeanTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value mean of normal distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value mean of normal distribution [%f]',v),'modal'));
    return;
end

%--------------

v = str2double(get(client_handles.normalSDTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for Standard deviation percentage of normal distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for standard deviation percentage of normal distribution [%f]',v),'modal'));
    return;
end

if v<0
    uiwait(errordlg(sprintf('Standard deviation percentage of normal distribution must be >=0 [%f]',v),'modal'));
    return;
end

if v>100
    uiwait(errordlg(sprintf('Standard deviation percentage of normal distribution must be <=100 [%f]',v),'modal'));
    return;
end

%------------------

v = str2double(get(client_handles.minUniformTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for minumum of uniform distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for minumum of uniform distribution [%f]',v),'modal'));
    return;
end

the_max = str2double(get(client_handles.maxUniformTag,'String'));
if v>=the_max
    uiwait(errordlg(sprintf('minumum of uniform distribution [%f] has to be less than the maximum value',v),'modal'));
    return;
end

%------------

v = str2double(get(client_handles.maxUniformTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for maximum of uniform distribution [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for maximum of uniform distribution [%f]',v),'modal'));
    return;
end

the_min = str2double(get(client_handles.minUniformTag,'String'));
if v<=the_min
    uiwait(errordlg(sprintf('maximum of uniform distribution [%f] has to be larger than the minimum value',v),'modal'));
    return;
end

%-----------------

v = str2double(get(client_handles.client_threshold_tag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for threshold percentage [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for threshold percentage [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('Threshold percentage must be > 0  [%f]',v),'modal'));
    return;
end

if v>100
    uiwait(errordlg(sprintf('Threshold percentage must be <= 100  [%f]',v),'modal'));
    return;
end


%----------------------

v = str2double(get(client_handles.client_point_impulse_radius_tag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for impulse radius [%s]',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for impulse radius [%f]',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('impulse radius must be > 0  [%d]',v),'modal'));
    return;
end

if ~(ceil(v) == floor(v))
    uiwait(errordlg(sprintf('impulse radius must be integer  [%f]',v),'modal'));
    return;
end

%----------------

v = str2double(get(client_handles.lambdaValueTag,'String'));
if ~isnumeric(v)
    uiwait(errordlg(sprintf('invalid value for lambda [%s] for poisson distribution',v),'modal'));
    return;
end

if isnan(v)
    uiwait(errordlg(sprintf('invalid value for lambda [%f] for poisson distribution',v),'modal'));
    return;
end

if v<=0
    uiwait(errordlg(sprintf('lambda > 0  [%d]',v),'modal'));
    return;
end

is_success = true;

end